package com.example.ueberwachungssystem;

import android.content.Context;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

public class ThreadDemo implements Runnable {
    private volatile boolean running = false;
    private Thread thread;
    private String threadname = "testThread";
    //Logger logger;
    TextView textViewWorkerThread;

    // Passing Activity's instance as argument on worker thread
    AppCompatActivity activity;
    public ThreadDemo(AppCompatActivity activity, TextView textViewWorkerThread){
        this.activity = activity;
        this.textViewWorkerThread = textViewWorkerThread;
    }
    //Method print which delegates access on MainActivity to runOnUiThread
    private void print(final String s) {
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewWorkerThread.setText(s);
            }
        });
    }

    @Override
    public void run() {
        int i = 0;
        while (running) {
            i++;
            print(String.valueOf(i));
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        //print(activity.getString(R.string.workerThread) + " endet mit " + i);
    }

    void start() {
        //logger.log("Starting " + threadname + "...");
        running = true;
        thread = new Thread(this);
        thread.setName(threadname);
        thread.start();
        //logger.log("..." + threadname + " started");
    }
    void stop() {
        if (!running) {
            //logger.log(threadname + " not running");
        } else {
            //logger.log("Stopping " + threadname + "...");
            running = false;
            while(true){
                try {
                    thread.join();
                    //logger.log("... " + threadname + " stopped");
                    break;
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
